/*
 Servotester für 5 Servos
 by Sven Peitz
 http://rfidakkuscan.de/

*/

#include <Servo.h>
#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define OLED_RESET 4
Adafruit_SSD1306 display(OLED_RESET);

#define NUMFLAKES 10
#define XPOS 0
#define YPOS 1
#define DELTAY 2


#define LOGO16_GLCD_HEIGHT 16
#define LOGO16_GLCD_WIDTH  16
static const unsigned char PROGMEM logo16_glcd_bmp[] =
{ B00000000, B11000000,
  B00000001, B11000000,
  B00000001, B11000000,
  B00000011, B11100000,
  B11110011, B11100000,
  B11111110, B11111000,
  B01111110, B11111111,
  B00110011, B10011111,
  B00011111, B11111100,
  B00001101, B01110000,
  B00011011, B10100000,
  B00111111, B11100000,
  B00111111, B11110000,
  B01111100, B11110000,
  B01110000, B01110000,
  B00000000, B00110000 };

#if (SSD1306_LCDHEIGHT != 64)
#error("Height incorrect, please fix Adafruit_SSD1306.h!");
#endif


Servo myservo1;  // create servo object to control a servo
Servo myservo2;  // create servo object to control a servo
Servo myservo3;  // create servo object to control a servo
Servo myservo4;  // create servo object to control a servo
Servo myservo5;  // create servo object to control a servo
Servo myservo6;  // create servo object to control a servo

int potpin = 0;  // analog pin used to connect the potentiometer
int val;    // variable to read the value from the analog pin
int steps = 0;
int zaehler = 0;
unsigned long Wartezeit = 10;
unsigned long previousMillis = 0; // speichert wie viele Sekunden seit derletzten
boolean automatic = false;
boolean down =false;
// constants won't change. They're used here to
// set pin numbers:
const int buttonPin = 2;     // the number of the pushbutton pin
// variables will change:
//int buttonState = 0;         // variable for reading the pushbutton status
//boolean middle = false;
volatile int state = LOW;

void setup()
{
  Serial.begin(9600);
  Serial.println("geht los");
  myservo1.attach(3);  // attaches the servo on pin 3 to the servo object
  myservo2.attach(6);  // attaches the servo on pin 6 to the servo object
  myservo3.attach(9);  // attaches the servo on pin 9 to the servo object
  myservo4.attach(10);  // attaches the servo on pin 10 to the servo object
  myservo5.attach(11);  // attaches the servo on pin 11 to the servo object
 // interrupt bei steigender Flanke auf Pin D2
  attachInterrupt(0, button, RISING);
   // by default, we'll generate the high voltage from the 3.3v line internally! (neat!)
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);  // initialize with the I2C addr 0x3D (for the 128x64)
  // init done

  // Clear the buffer.
  display.clearDisplay();

}

void loop()
{
  if (steps >= 2) {
      automatic = true;


  }
  else{
      automatic = false;


  }
  // read the state of the pushbutton value:
 // buttonState = digitalRead(buttonPin);
  val = analogRead(potpin);            // reads the value of the potentiometer (value between 0 and 1023)
  val = map(val, 0, 1023, 0, 180);     // scale it to use it with the servo (value between 0 and 180)

  if (automatic == true){
          display.clearDisplay();
          display.setTextSize(1);
          display.setTextColor(WHITE);
          display.setCursor(0,0);

          if ((zaehler <180) && (down == false)){
          //for (int i=0; i <= 180; i++){
              if (millis() - previousMillis > Wartezeit) {
              zaehler +=1;
              myservo1.write(zaehler);  // Turn Servo
              myservo2.write(zaehler);  // Turn Servo
              myservo3.write(zaehler);  // Turn Servo
              myservo4.write(zaehler);  // Turn Servo
              myservo5.write(zaehler);  // Turn Servo
              display.clearDisplay();
              display.setTextSize(2);
              display.setTextColor(WHITE);
              display.setCursor(0,0);
              display.print(zaehler,DEC);
              if (zaehler<10){ display.print("  Grad");}
              if (zaehler>=10 && zaehler<100){ display.print(" Grad");}
              if (zaehler>=100){ display.print("Grad");}
              if (zaehler<=45) display.drawLine(64, 63,  19, 63-zaehler,  WHITE);
              if (zaehler>45 && zaehler<=90) display.drawLine(64, 63, 19+zaehler-45, 19,  WHITE);
              if (zaehler>90 && zaehler<=135)display.drawLine(64, 63, 19+zaehler-45, 19,  WHITE);
              if (zaehler>135)display.drawLine(64, 63,  109, 19+zaehler-135,  WHITE);
              display.setTextSize(1);
              display.setTextColor(WHITE);
             // display.setCursor(9,110);
              display.print("  Auto");

              display.setTextSize(1);
              display.setTextColor(WHITE);
              display.setCursor(0,17);
              display.print("45");
              display.setCursor(0,57);
              display.print("0");
              display.setCursor(110,17);
              display.print("135");
              display.setCursor(110,57);
              display.print("180");
              display.setCursor(55,17);
              display.print("90");
              display.display();
             if (zaehler >= 180){down = true;}
             previousMillis = millis();
             }
        //  delay(10);
      }
         if ((zaehler >0) && (down == true)){
      //if (down == true){
      //for (int i=180; i >= 0; i--){

            if (millis() - previousMillis > Wartezeit) {
            zaehler -=1;
            myservo1.write(zaehler);  // Turn Servo
            myservo2.write(zaehler);  // Turn Servo
            myservo3.write(zaehler);  // Turn Servo
            myservo4.write(zaehler);  // Turn Servo
            myservo5.write(zaehler);  // Turn Servo
            display.clearDisplay();
            display.setTextSize(2);
            display.setTextColor(WHITE);
            display.setCursor(0,0);
            display.print(zaehler,DEC);
            if (zaehler<10){ display.print("  Grad");}
            if (zaehler>=10 && zaehler<100){ display.print(" Grad");}
            if (zaehler>=100){ display.print("Grad");}
            if (zaehler<=45) display.drawLine(64, 63,  19, 63-zaehler,  WHITE);
            if (zaehler>45 && zaehler<=90) display.drawLine(64, 63, 19+zaehler-45, 19,  WHITE);
            if (zaehler>90 && zaehler<=135)display.drawLine(64, 63, 19+zaehler-45, 19,  WHITE);
            if (zaehler>135)display.drawLine(64, 63,  109, 19+zaehler-135,  WHITE);
            display.setTextSize(1);
            display.setTextColor(WHITE);
        //    display.setCursor(6,90);
            display.print("  Auto");
            display.setTextColor(WHITE);
            display.setCursor(0,17);
            display.print("45");
            display.setCursor(0,57);
            display.print("0");
            display.setCursor(110,17);
            display.print("135");
            display.setCursor(110,57);
            display.print("180");
            display.setCursor(55,17);
            display.print("90");
            display.display();
            if (zaehler <= 0){down = false;}
             previousMillis = millis();
     }
  }}

  else{

      if ((state == HIGH) && (automatic == false)) {
            display.clearDisplay();
            // Servos in Mittel Stellung 90 Grad:
            int  i=90;
            myservo1.write(i);                  // sets the servo position according to the scaled value
            myservo2.write(i);                  // sets the servo position according to the scaled value
            myservo3.write(i);                  // sets the servo position according to the scaled value
            myservo4.write(i);                  // sets the servo position according to the scaled value
            myservo5.write(i);                  // sets the servo position according to the scaled value
            display.clearDisplay();
            display.setTextSize(2);
            display.setTextColor(WHITE);
            display.setCursor(0,0);
            display.print("90");
            if (i<10){ display.print("  Grad");}
            if (i>=10 && i<100){ display.print(" Grad");}
            if (i>=100){ display.print("Grad");}
            if (i<=45) display.drawLine(64, 63,  19, 63-i,  WHITE);
            if (i>45 && i<=90) display.drawLine(64, 63, 19+i-45, 19,  WHITE);
            if (i>90 && i<=135)display.drawLine(64, 63, 19+i-45, 19,  WHITE);
            if (i>135)display.drawLine(64, 63,  109, 19+i-135,  WHITE);
            display.setTextSize(1);
            display.setTextColor(WHITE);
           // display.setCursor(9,110);
            display.print("  Mitte");
            display.setTextSize(1);
            display.setTextColor(WHITE);
            display.setCursor(0,17);
            display.print("45");
            display.setCursor(0,57);
            display.print("0");
            display.setCursor(110,17);
            display.print("135");
            display.setCursor(110,57);
            display.print("180");
            display.setCursor(55,17);
            display.print("90");
            display.display();

      }
      else {
            display.clearDisplay();
            // Normal Betrieb Poti Bewegung folgen:
            int i=val;
            myservo1.write(i);                  // sets the servo position according to the scaled value
            myservo2.write(i);                  // sets the servo position according to the scaled value
            myservo3.write(i);                  // sets the servo position according to the scaled value
            myservo4.write(i);                  // sets the servo position according to the scaled value
            myservo5.write(i);                  // sets the servo position according to the scaled value
            display.clearDisplay();
            display.setTextSize(2);
            display.setTextColor(WHITE);
            display.setCursor(0,0);
            display.print(i,DEC);
            if (i<10){ display.print("  Grad");}
            if (i>=10 && i<100){ display.print(" Grad");}
            if (i>=100){ display.print("Grad");}
            if (i<=45) display.drawLine(64, 63,  19, 63-i,  WHITE);
            if (i>45 && i<=90) display.drawLine(64, 63, 19+i-45, 19,  WHITE);
            if (i>90 && i<=135)display.drawLine(64, 63, 19+i-45, 19,  WHITE);
            if (i>135)display.drawLine(64, 63,  109, 19+i-135,  WHITE);
            display.setTextSize(1);
            display.setTextColor(WHITE);
           // display.setCursor(9,110);
            display.print("  Poti");
            display.setTextSize(1);
            display.setTextColor(WHITE);
            display.setCursor(0,17);
            display.print("45");
            display.setCursor(0,57);
            display.print("0");
            display.setCursor(110,17);
            display.print("135");
            display.setCursor(110,57);
            display.print("180");
            display.setCursor(55,17);
            display.print("90");
            display.display();
        }
      delay(10);                           // waits for the servo to get there
    }
  }

  //End Loop

 // check if the pushbutton is pressed.
void button()
{
  state = !state;
  steps = steps +1;
  if (automatic == true){
     steps = 0;
  }
}
